diff --git a/Makefile.am b/Makefile.am
index 2129472..c1bd594 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -13,7 +13,8 @@ SUBDIRS = @platform_with_platform@ \
 	  helper/test \
 	  doc \
 	  example \
-	  scripts
+	  scripts \
+	  pcap
 
 @DX_RULES@
 
diff --git a/configure.ac b/configure.ac
index 7cd6670..1ef9739 100644
--- a/configure.ac
+++ b/configure.ac
@@ -232,6 +232,7 @@ AC_CONFIG_FILES([Makefile
 		 pkgconfig/libodp-linux.pc
 		 pkgconfig/libodphelper-linux.pc
 		 scripts/Makefile
+		 pcap/Makefile
 		 ])
 
 AC_SEARCH_LIBS([timer_create],[rt posix4])
diff --git a/example/l2fwd_simple/Makefile.am b/example/l2fwd_simple/Makefile.am
index fe20654..4cb5462 100644
--- a/example/l2fwd_simple/Makefile.am
+++ b/example/l2fwd_simple/Makefile.am
@@ -14,4 +14,4 @@ if HAVE_PCAP
 TESTS = l2fwd_simple_run.sh
 endif
 endif
-EXTRA_DIST = l2fwd_simple_run.sh udp64.pcap
+EXTRA_DIST = l2fwd_simple_run.sh
diff --git a/example/l2fwd_simple/l2fwd_simple_run.sh b/example/l2fwd_simple/l2fwd_simple_run.sh
index 292d0e3..7a49f57 100755
--- a/example/l2fwd_simple/l2fwd_simple_run.sh
+++ b/example/l2fwd_simple/l2fwd_simple_run.sh
@@ -6,7 +6,7 @@
 # SPDX-License-Identifier:     BSD-3-Clause
 #
 
-PCAP_IN=`find . ${TEST_DIR} $(dirname $0) -name udp64.pcap -print -quit`
+PCAP_IN=`find . ../../pcap -name udp64.pcap -print -quit`
 echo "using PCAP_IN = ${PCAP_IN}"
 
 ./odp_l2fwd_simple pcap:in=${PCAP_IN} pcap:out=pcapout.pcap 02:00:00:00:00:01 02:00:00:00:00:02 &
diff --git a/example/l2fwd_simple/udp64.pcap b/example/l2fwd_simple/udp64.pcap
deleted file mode 100644
index 45f9d6e6341a331125e1e3e49ab8ad1e71b20712..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/example/packet/Makefile.am b/example/packet/Makefile.am
index af729b0..4abd8ef 100644
--- a/example/packet/Makefile.am
+++ b/example/packet/Makefile.am
@@ -14,4 +14,4 @@ if HAVE_PCAP
 TESTS = pktio_run.sh
 endif
 endif
-EXTRA_DIST = pktio_run.sh udp64.pcap
+EXTRA_DIST = pktio_run.sh
diff --git a/example/packet/pktio_run.sh b/example/packet/pktio_run.sh
index 3adb2d6..5730c35 100755
--- a/example/packet/pktio_run.sh
+++ b/example/packet/pktio_run.sh
@@ -6,7 +6,7 @@
 # SPDX-License-Identifier:     BSD-3-Clause
 #
 
-PCAP_IN=`find . ${TEST_DIR} $(dirname $0) -name udp64.pcap -print -quit`
+PCAP_IN=`find . ../../pcap -name udp64.pcap -print -quit`
 PCAP_OUT="pcapout.pcap"
 PCAP_IN_SIZE=`stat -c %s ${PCAP_IN}`
 echo "using PCAP in=${PCAP_IN}:out=${PCAP_OUT} size %${PCAP_IN_SIZE}"
diff --git a/example/packet/udp64.pcap b/example/packet/udp64.pcap
deleted file mode 100644
index 45f9d6e6341a331125e1e3e49ab8ad1e71b20712..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/example/switch/Makefile.am b/example/switch/Makefile.am
index 4134bcf..fc5e9d0 100644
--- a/example/switch/Makefile.am
+++ b/example/switch/Makefile.am
@@ -14,4 +14,4 @@ if HAVE_PCAP
 TESTS = switch_run.sh
 endif
 endif
-EXTRA_DIST = switch_run.sh udp64.pcap
+EXTRA_DIST = switch_run.sh
diff --git a/example/switch/switch_run.sh b/example/switch/switch_run.sh
index 3f8f9db..be0bd9d 100755
--- a/example/switch/switch_run.sh
+++ b/example/switch/switch_run.sh
@@ -9,7 +9,7 @@
 NUM_RX_PORT=3
 RETVAL=0
 
-PCAP_IN=`find . ${TEST_DIR} $(dirname $0) -name udp64.pcap -print -quit`
+PCAP_IN=`find . ../../pcap -name udp64.pcap -print -quit`
 
 echo "Switch test using PCAP_IN = ${PCAP_IN}"
 
diff --git a/example/switch/udp64.pcap b/example/switch/udp64.pcap
deleted file mode 100644
index 45f9d6e6341a331125e1e3e49ab8ad1e71b20712..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/pcap/Makefile.am b/pcap/Makefile.am
new file mode 100644
index 0000000..31fc32e
--- /dev/null
+++ b/pcap/Makefile.am
@@ -0,0 +1 @@
+EXTRA_DIST = udp64.pcap