diff --git a/Makefile.am b/Makefile.am
index 2129472..625748a 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -9,7 +9,6 @@ AM_DISTCHECK_CONFIGURE_FLAGS = --enable-test-cpp \
 SUBDIRS = @platform_with_platform@ \
 	  helper \
 	  test \
-	  @platform_with_platform_test@ \
 	  helper/test \
 	  doc \
 	  example \
diff --git a/configure.ac b/configure.ac
index c87755b..f3952db 100644
--- a/configure.ac
+++ b/configure.ac
@@ -107,7 +107,6 @@ AC_ARG_WITH([platform],
 
 AC_SUBST([with_platform])
 AC_SUBST([platform_with_platform], ["platform/${with_platform}"])
-AC_SUBST([platform_with_platform_test], ["platform/${with_platform}/test"])
 
 ##########################################################################
 # Run platform specific checks and settings
@@ -116,6 +115,7 @@ IMPLEMENTATION_NAME=""
 if test "${with_platform}" == "linux-generic";
 then
     m4_include([./platform/linux-generic/m4/configure.m4])
+    m4_include([./test/platform/linux-generic/m4/configure.m4])
     IMPLEMENTATION_NAME="odp-linux"
 else
     echo "UNSUPPORTED PLATFORM: ${with_platform}"
diff --git a/platform/linux-generic/m4/configure.m4 b/platform/linux-generic/m4/configure.m4
index 5380046..1b1b883 100644
--- a/platform/linux-generic/m4/configure.m4
+++ b/platform/linux-generic/m4/configure.m4
@@ -36,9 +36,4 @@ m4_include([platform/linux-generic/m4/odp_dpdk.m4])
 m4_include([platform/linux-generic/m4/odp_ipc.m4])
 m4_include([platform/linux-generic/m4/odp_schedule.m4])
 
-AC_CONFIG_FILES([platform/linux-generic/Makefile
-		 platform/linux-generic/test/Makefile
-		 platform/linux-generic/test/shmem/Makefile
-		 platform/linux-generic/test/pktio/Makefile
-		 platform/linux-generic/test/pktio_ipc/Makefile
-		 platform/linux-generic/test/ring/Makefile])
+AC_CONFIG_FILES([platform/linux-generic/Makefile])
diff --git a/test/Makefile.am b/test/Makefile.am
index 4a75364..8bab8fd 100644
--- a/test/Makefile.am
+++ b/test/Makefile.am
@@ -1,5 +1,5 @@
 SUBDIRS = performance miscellaneous
 
 if cunit_support
-    SUBDIRS += validation
+    SUBDIRS += validation @platform_with_platform@
 endif
diff --git a/test/performance/odp_l2fwd_run.sh b/test/performance/odp_l2fwd_run.sh
index cab97a8..fc3d05d 100755
--- a/test/performance/odp_l2fwd_run.sh
+++ b/test/performance/odp_l2fwd_run.sh
@@ -37,8 +37,8 @@ elif  [ "$ODP_PLATFORM" = "" ]; then
 	echo "$0: error: ODP_PLATFORM must be defined"
 	# not skipped as this should never happen via "make check"
 	exit 1
-elif [ -f ${TEST_SRC_DIR}/../../platform/$ODP_PLATFORM/test/pktio/pktio_env ]; then
-	. ${TEST_SRC_DIR}/../../platform/$ODP_PLATFORM/test/pktio/pktio_env
+elif [ -f ${TEST_SRC_DIR}/../platform/$ODP_PLATFORM/pktio/pktio_env ]; then
+	. ${TEST_SRC_DIR}/../platform/$ODP_PLATFORM/pktio/pktio_env
 else
 	echo "BUG: unable to find pktio_env!"
 	echo "pktio_env has to be in current directory or in platform/\$ODP_PLATFORM/test."
diff --git a/platform/linux-generic/test/.gitignore b/test/platform/linux-generic/.gitignore
similarity index 100%
rename from platform/linux-generic/test/.gitignore
rename to test/platform/linux-generic/.gitignore
diff --git a/platform/linux-generic/test/Makefile.am b/test/platform/linux-generic/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/Makefile.am
rename to test/platform/linux-generic/Makefile.am
diff --git a/platform/linux-generic/test/Makefile.inc b/test/platform/linux-generic/Makefile.inc
similarity index 100%
rename from platform/linux-generic/test/Makefile.inc
rename to test/platform/linux-generic/Makefile.inc
diff --git a/test/platform/linux-generic/m4/configure.m4 b/test/platform/linux-generic/m4/configure.m4
new file mode 100644
index 0000000..8c3db21
--- /dev/null
+++ b/test/platform/linux-generic/m4/configure.m4
@@ -0,0 +1,5 @@
+AC_CONFIG_FILES([test/platform/linux-generic/Makefile
+		 test/platform/linux-generic/shmem/Makefile
+		 test/platform/linux-generic/pktio/Makefile
+		 test/platform/linux-generic/pktio_ipc/Makefile
+		 test/platform/linux-generic/ring/Makefile])
diff --git a/platform/linux-generic/test/pktio/.gitignore b/test/platform/linux-generic/pktio/.gitignore
similarity index 100%
rename from platform/linux-generic/test/pktio/.gitignore
rename to test/platform/linux-generic/pktio/.gitignore
diff --git a/platform/linux-generic/test/pktio/Makefile.am b/test/platform/linux-generic/pktio/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/pktio/Makefile.am
rename to test/platform/linux-generic/pktio/Makefile.am
diff --git a/platform/linux-generic/test/pktio/pktio_env b/test/platform/linux-generic/pktio/pktio_env
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_env
rename to test/platform/linux-generic/pktio/pktio_env
diff --git a/platform/linux-generic/test/pktio/pktio_run.sh b/test/platform/linux-generic/pktio/pktio_run.sh
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run.sh
rename to test/platform/linux-generic/pktio/pktio_run.sh
diff --git a/platform/linux-generic/test/pktio/pktio_run_dpdk.sh b/test/platform/linux-generic/pktio/pktio_run_dpdk.sh
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_dpdk.sh
rename to test/platform/linux-generic/pktio/pktio_run_dpdk.sh
diff --git a/platform/linux-generic/test/pktio/pktio_run_netmap.sh b/test/platform/linux-generic/pktio/pktio_run_netmap.sh
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_netmap.sh
rename to test/platform/linux-generic/pktio/pktio_run_netmap.sh
diff --git a/platform/linux-generic/test/pktio/pktio_run_pcap.sh b/test/platform/linux-generic/pktio/pktio_run_pcap.sh
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_pcap.sh
rename to test/platform/linux-generic/pktio/pktio_run_pcap.sh
diff --git a/platform/linux-generic/test/pktio/pktio_run_tap.sh b/test/platform/linux-generic/pktio/pktio_run_tap.sh
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_tap.sh
rename to test/platform/linux-generic/pktio/pktio_run_tap.sh
diff --git a/platform/linux-generic/test/pktio_ipc/.gitignore b/test/platform/linux-generic/pktio_ipc/.gitignore
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/.gitignore
rename to test/platform/linux-generic/pktio_ipc/.gitignore
diff --git a/platform/linux-generic/test/pktio_ipc/Makefile.am b/test/platform/linux-generic/pktio_ipc/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/Makefile.am
rename to test/platform/linux-generic/pktio_ipc/Makefile.am
diff --git a/platform/linux-generic/test/pktio_ipc/ipc_common.c b/test/platform/linux-generic/pktio_ipc/ipc_common.c
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/ipc_common.c
rename to test/platform/linux-generic/pktio_ipc/ipc_common.c
diff --git a/platform/linux-generic/test/pktio_ipc/ipc_common.h b/test/platform/linux-generic/pktio_ipc/ipc_common.h
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/ipc_common.h
rename to test/platform/linux-generic/pktio_ipc/ipc_common.h
diff --git a/platform/linux-generic/test/pktio_ipc/pktio_ipc1.c b/test/platform/linux-generic/pktio_ipc/pktio_ipc1.c
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/pktio_ipc1.c
rename to test/platform/linux-generic/pktio_ipc/pktio_ipc1.c
diff --git a/platform/linux-generic/test/pktio_ipc/pktio_ipc2.c b/test/platform/linux-generic/pktio_ipc/pktio_ipc2.c
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/pktio_ipc2.c
rename to test/platform/linux-generic/pktio_ipc/pktio_ipc2.c
diff --git a/platform/linux-generic/test/pktio_ipc/pktio_ipc_run.sh b/test/platform/linux-generic/pktio_ipc/pktio_ipc_run.sh
similarity index 100%
rename from platform/linux-generic/test/pktio_ipc/pktio_ipc_run.sh
rename to test/platform/linux-generic/pktio_ipc/pktio_ipc_run.sh
diff --git a/platform/linux-generic/test/ring/.gitignore b/test/platform/linux-generic/ring/.gitignore
similarity index 100%
rename from platform/linux-generic/test/ring/.gitignore
rename to test/platform/linux-generic/ring/.gitignore
diff --git a/platform/linux-generic/test/ring/Makefile.am b/test/platform/linux-generic/ring/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/ring/Makefile.am
rename to test/platform/linux-generic/ring/Makefile.am
diff --git a/platform/linux-generic/test/ring/ring_basic.c b/test/platform/linux-generic/ring/ring_basic.c
similarity index 100%
rename from platform/linux-generic/test/ring/ring_basic.c
rename to test/platform/linux-generic/ring/ring_basic.c
diff --git a/platform/linux-generic/test/ring/ring_main.c b/test/platform/linux-generic/ring/ring_main.c
similarity index 100%
rename from platform/linux-generic/test/ring/ring_main.c
rename to test/platform/linux-generic/ring/ring_main.c
diff --git a/platform/linux-generic/test/ring/ring_stress.c b/test/platform/linux-generic/ring/ring_stress.c
similarity index 100%
rename from platform/linux-generic/test/ring/ring_stress.c
rename to test/platform/linux-generic/ring/ring_stress.c
diff --git a/platform/linux-generic/test/ring/ring_suites.c b/test/platform/linux-generic/ring/ring_suites.c
similarity index 100%
rename from platform/linux-generic/test/ring/ring_suites.c
rename to test/platform/linux-generic/ring/ring_suites.c
diff --git a/platform/linux-generic/test/ring/ring_suites.h b/test/platform/linux-generic/ring/ring_suites.h
similarity index 100%
rename from platform/linux-generic/test/ring/ring_suites.h
rename to test/platform/linux-generic/ring/ring_suites.h
diff --git a/platform/linux-generic/test/run-test b/test/platform/linux-generic/run-test
similarity index 100%
rename from platform/linux-generic/test/run-test
rename to test/platform/linux-generic/run-test
diff --git a/platform/linux-generic/test/shmem/.gitignore b/test/platform/linux-generic/shmem/.gitignore
similarity index 100%
rename from platform/linux-generic/test/shmem/.gitignore
rename to test/platform/linux-generic/shmem/.gitignore
diff --git a/platform/linux-generic/test/shmem/Makefile.am b/test/platform/linux-generic/shmem/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/shmem/Makefile.am
rename to test/platform/linux-generic/shmem/Makefile.am
diff --git a/platform/linux-generic/test/shmem/shmem.h b/test/platform/linux-generic/shmem/shmem.h
similarity index 100%
rename from platform/linux-generic/test/shmem/shmem.h
rename to test/platform/linux-generic/shmem/shmem.h
diff --git a/platform/linux-generic/test/shmem/shmem_common.h b/test/platform/linux-generic/shmem/shmem_common.h
similarity index 100%
rename from platform/linux-generic/test/shmem/shmem_common.h
rename to test/platform/linux-generic/shmem/shmem_common.h
diff --git a/platform/linux-generic/test/shmem/shmem_linux.c b/test/platform/linux-generic/shmem/shmem_linux.c
similarity index 100%
rename from platform/linux-generic/test/shmem/shmem_linux.c
rename to test/platform/linux-generic/shmem/shmem_linux.c
diff --git a/platform/linux-generic/test/shmem/shmem_linux.h b/test/platform/linux-generic/shmem/shmem_linux.h
similarity index 100%
rename from platform/linux-generic/test/shmem/shmem_linux.h
rename to test/platform/linux-generic/shmem/shmem_linux.h
diff --git a/platform/linux-generic/test/shmem/shmem_odp.c b/test/platform/linux-generic/shmem/shmem_odp.c
similarity index 100%
rename from platform/linux-generic/test/shmem/shmem_odp.c
rename to test/platform/linux-generic/shmem/shmem_odp.c
diff --git a/platform/linux-generic/test/shmem/shmem_odp.h b/test/platform/linux-generic/shmem/shmem_odp.h
similarity index 100%
rename from platform/linux-generic/test/shmem/shmem_odp.h
rename to test/platform/linux-generic/shmem/shmem_odp.h