diff --git a/Makefile.am b/Makefile.am
index e1ea07d5..7398499c 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,11 +1,5 @@
 ACLOCAL_AMFLAGS=-I m4
-AM_DISTCHECK_CONFIGURE_FLAGS = --enable-test-cpp	\
-			       --enable-test-example	\
-			       --enable-test-helper	\
-			       --enable-test-perf	\
-			       --enable-test-perf-proc	\
-			       --enable-test-vald	\
-			       --enable-user-guides	\
+AM_DISTCHECK_CONFIGURE_FLAGS = --enable-user-guides	\
 			       --with-testdir
 
 #@with_platform@ works alone in subdir but not as part of a path???
diff --git a/configure.ac b/configure.ac
index c1811003..c076b4cc 100644
--- a/configure.ac
+++ b/configure.ac
@@ -214,12 +214,6 @@ AC_SUBST([testdir])
 AM_CONDITIONAL([SDK_INSTALL_PATH_], [test "x${SDK_INSTALL_PATH_}" = "x1"])
 AM_CONDITIONAL([test_installdir], [test "$testdir" != ""])
 AM_CONDITIONAL([cunit_support], [test x$cunit_support = xyes ])
-AM_CONDITIONAL([test_vald], [test x$test_vald = xyes ])
-AM_CONDITIONAL([test_perf], [test x$test_perf = xyes ])
-AM_CONDITIONAL([test_perf_proc], [test x$test_perf_proc = xyes ])
-AM_CONDITIONAL([test_cpp], [test x$test_cpp = xyes ])
-AM_CONDITIONAL([test_helper], [test x$test_helper = xyes ])
-AM_CONDITIONAL([test_example], [test x$test_example = xyes ])
 AM_CONDITIONAL([HAVE_DOXYGEN], [test "x${DOXYGEN}" = "xdoxygen"])
 AM_CONDITIONAL([user_guide], [test "x${user_guides}" = "xyes" ])
 AM_CONDITIONAL([HAVE_MSCGEN], [test "x${MSCGEN}" = "xmscgen"])
diff --git a/example/m4/configure.m4 b/example/m4/configure.m4
index 18218d05..cab7f8b8 100644
--- a/example/m4/configure.m4
+++ b/example/m4/configure.m4
@@ -1,14 +1,11 @@
 ##########################################################################
 # Enable/disable test-example
 ##########################################################################
-test_example=no
 AC_ARG_ENABLE([test-example],
-    [  --enable-test-example   run basic test against examples],
-    [if test "x$enableval" = "xyes"; then
-        test_example=yes
-     else
-        test_example=no
-    fi])
+    [AS_HELP_STRING([--enable-test-example], [run basic test against examples])],
+    [test_example=$enableval],
+    [test_example=yes])
+AM_CONDITIONAL([test_example], [test x$test_example = xyes ])
 
 AC_CONFIG_FILES([example/classifier/Makefile
 		 example/generator/Makefile
diff --git a/helper/m4/configure.m4 b/helper/m4/configure.m4
index 343f5e3c..2e2943d1 100644
--- a/helper/m4/configure.m4
+++ b/helper/m4/configure.m4
@@ -1,12 +1,11 @@
 ##########################################################################
 # Enable/disable test-helper
 ##########################################################################
-test_helper=no
 AC_ARG_ENABLE([test-helper],
-    [  --enable-test-helper      run test in helper/test],
-    [if test "x$enableval" = "xyes"; then
-        test_helper=yes
-    fi])
+    [AS_HELP_STRING([--enable-test-helper], [run test in helper/test])],
+    [test_helper=$enableval],
+    [test_helper=yes])
+AM_CONDITIONAL([test_helper], [test x$test_helper = xyes ])
 
 ##########################################################################
 # Enable/disable helper-ext
diff --git a/test/common_plat/m4/miscellaneous.m4 b/test/common_plat/m4/miscellaneous.m4
index cc881edb..dac236a6 100644
--- a/test/common_plat/m4/miscellaneous.m4
+++ b/test/common_plat/m4/miscellaneous.m4
@@ -1,9 +1,8 @@
 ##########################################################################
 # Enable/disable test-cpp
 ##########################################################################
-test_cpp=no
 AC_ARG_ENABLE([test-cpp],
-    [  --enable-test-cpp       run basic test aginast cpp],
-    [if test "x$enableval" = "xyes"; then
-        test_cpp=yes
-    fi])
+    [AS_HELP_STRING([--disable-test-cpp], [run basic test aginast cpp])],
+    [test_cpp=$enableval],
+    [test_cpp=yes])
+AM_CONDITIONAL([test_cpp], [test x$test_cpp = xyes ])
diff --git a/test/common_plat/m4/performance.m4 b/test/common_plat/m4/performance.m4
index 1e2000d9..34270e8d 100644
--- a/test/common_plat/m4/performance.m4
+++ b/test/common_plat/m4/performance.m4
@@ -1,9 +1,8 @@
 ##########################################################################
 # Enable/disable test-perf
 ##########################################################################
-test_perf=no
 AC_ARG_ENABLE([test-perf],
-    [  --enable-test-perf      run test in test/performance],
-    [if test "x$enableval" = "xyes"; then
-        test_perf=yes
-    fi])
+    [AS_HELP_STRING([--enable-test-perf], [run test in test/performance])],
+    [test_perf=$enableval],
+    [test_perf=yes])
+AM_CONDITIONAL([test_perf], [test x$test_perf = xyes ])
diff --git a/test/common_plat/m4/validation.m4 b/test/common_plat/m4/validation.m4
index 67edac7a..b2a2f75d 100644
--- a/test/common_plat/m4/validation.m4
+++ b/test/common_plat/m4/validation.m4
@@ -1,30 +1,19 @@
 ##########################################################################
 # Enable/disable Unit tests
 ##########################################################################
-cunit_support=no
-test_vald=no
 AC_ARG_ENABLE([test_vald],
-    [  --enable-test-vald       run test in test/validation],
-    [if test x$enableval = xyes; then
-        test_vald=yes
-        cunit_support=yes
-    fi])
-
-##########################################################################
-# Enable/disable Unit tests
-##########################################################################
-AC_ARG_ENABLE([cunit_support],
-    [  --enable-cunit-support  include cunit infrastructure],
-    [if test x$enableval = xyes; then
-        cunit_support=yes
-    fi])
+    [AS_HELP_STRING([--enable-test-vald], [run test in test/validation])],
+    [test_vald=$enableval],
+    [test_vald=yes])
+AM_CONDITIONAL([test_vald], [test x$test_vald = xyes ])
 
 ##########################################################################
 # Set optional CUnit path
 ##########################################################################
+cunit_support=$test_vald
 AC_ARG_WITH([cunit-path],
-AC_HELP_STRING([--with-cunit-path=DIR   path to CUnit libs and headers],
-               [(or in the default path if not specified).]),
+AC_HELP_STRING([--with-cunit-path=DIR],
+	       [path to CUnit libs and headers (if not present at default path)]),
     [CUNIT_PATH=$withval
      CUNIT_CPPFLAGS="-I$CUNIT_PATH/include"
      CUNIT_LIBS="-L$CUNIT_PATH/lib"
diff --git a/test/linux-generic/m4/performance.m4 b/test/linux-generic/m4/performance.m4
index 7f54b96d..05b3a990 100644
--- a/test/linux-generic/m4/performance.m4
+++ b/test/linux-generic/m4/performance.m4
@@ -1,9 +1,8 @@
 ##########################################################################
 # Enable/disable test-perf-proc
 ##########################################################################
-test_perf_proc=no
 AC_ARG_ENABLE([test-perf-proc],
-    [  --enable-test-perf-proc      run test in test/performance in process mode],
-    [if test "x$enableval" = "xyes"; then
-        test_perf_proc=yes
-    fi])
+    [AS_HELP_STRING([--enable-test-perf-proc], [run test in test/performance in process mode])],
+    [test_perf_proc=$enableval],
+    [test_perf_proc=yes])
+AM_CONDITIONAL([test_perf_proc], [test x$test_perf_proc = xyes ])